-- **************************************************************************
--   TitanPalsToolTip.lua
--
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanPals", true );

-- **************************************************************************
-- NAME : TitanPanelPalsButton_SetTooltipText()
-- DESC : Build Firends Tooltip for Titan Panel
-- **************************************************************************
function TitanPanelPals_SetTooltip()
     local np, op = GetNumFriends();

     local tempDB = TitanPals_DataUtils( "Update" );
     local tooltipDB = {};

     local right, left, palsDB;
     palsDB = ( "%s:%s" ):format( TitanPalsProfile.Faction, TitanPalsProfile.Realm );
     -- RealID Friends
     if ( TitanPals.Settings.ShowBNTooltip ) then
          if ( tempDB.BNT == 0 ) then
               GameTooltip:AddLine( LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b );
               GameTooltip:AddLine( LB["TITAN_PALS_TOOLTIP_NOREALID_FRIENDS"] );
               GameTooltip:AddLine( "\n" );
          else
               GameTooltip:AddLine( LB["TITAN_PALS_REAL_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b );
               if ( tempDB.BNO > 0 ) then
                    table.foreach( tempDB.BN, function( Key, Data )
                              table.foreach( Data.Toons, function( Toon, tData )
                                        tData.accountName = Key;

                                        --[[ This is ALPHA code and will be altered as needed ]]--
                                        if ( tData.client == BNET_CLIENT_SC2 ) then
                                             tData.level = BNET_CLIENT_SC2;
                                             tData.class = BNET_CLIENT_SC2;
                                             tData.realmName = LB["TITAN_PALS_CONFIG_STARCRAFT"]; --"Starcraft II"
                                        elseif ( tData.client == BNET_CLIENT_D3 ) then
                                             tData.level = BNET_CLIENT_D3;
                                             tData.class = BNET_CLIENT_D3;
                                             tData.realmName = LB["TITAN_PALS_CONFIG_DIABLO"]; --"Diablo III"
                                        end
                                        tData.realIDName = TitanPals_CoreUtils( "ToolTipID", TitanPals.Settings.RealIDFormat, tData );
                                        tData.right, tData.left = TitanPals_CoreUtils( "ToolTipN", TitanPals.Settings.TFormat, tData );
                                        GameTooltip:AddDoubleLine( tData.right, tData.left );


                                   end
                              )
                         end
                    )
                    GameTooltip:AddLine( "\n" );
               else 
                    GameTooltip:AddLine( ( " %s" ):format( LB["TITAN_PALS_TOOLTIP_NOREALPALS"] ) );
                    GameTooltip:AddLine( "\n" );
               end
          end
     end
     GameTooltip:AddLine( LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b );
     if ( tempDB.NP == 0 ) then
          GameTooltip:AddLine( LB["TITAN_PALS_TOOLTIP_EMPTY"] );
     else
          -- For showing online friends
          if ( tempDB.NPO == 0 ) then
               GameTooltip:AddLine( LB["TITAN_PALS_TOOLTIP_NOPALS"] );
          else
               table.foreach( tempDB.PALS, function( Key, Data )
                         right, left = TitanPals_CoreUtils( "ToolTipN", TitanPals.Settings.TFormat, Data );
                         GameTooltip:AddDoubleLine( right, left );
                    end
               )
          end
          -- For showing offline friends  
          if ( TitanPals.Settings.ShowOffline ) then
               GameTooltip:AddLine( "\n" );
               GameTooltip:AddLine( TitanPals_ColorUtils( "GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_OFF"] ) );
	       local pcount = 0;
               local offLine = {};
	       local lIndex = TitanPalsLists[palsDB];
               local aIndex = TitanPalsAlts[palsDB];
               local uName = UnitName( "player" )
               table.foreach( lIndex, function( Key, Data )
                         if ( not tempDB.PALS or not tempDB.PALS[Key] ) then
                              if ( uName ~= Key ) then 
                                   if ( not offLine[Key] ) then offLine[Key] = {}; end
                                   if ( aIndex[Key] ) then
                                        offLine[Key].isALT = true;
                                   else
                                        offLine[Key].isALT = false;
                                   end
                                   offLine[Key].toonName = Key;
                                   offLine[Key].pType = "pals";
                                   offLine[Key].client = BNET_CLIENT_WOW
                                   offLine[Key].level = lIndex[Key].Level
                                   offLine[Key].class = lIndex[Key].Class
                                   if ( lIndex[Key].Note == "na" ) then
                                        offLine[Key].note = "";
                                   else
                                        offLine[Key].note = lIndex[Key].Note;
                                   end
                                   local ol = TitanPals_ColorUtils( "GetCText", "gray", LB["TITAN_PALS_TOOLTIP_OFFLINE"] );
                                   offLine[Key].zone = ol;
                                   right, left = TitanPals_CoreUtils( "ToolTipN", TitanPals.Settings.TFormat, offLine[Key] );
                                   if ( TitanPals.Settings.NoAlts and aIndex[Key] ) then 
                                        -- GameTooltip:AddDoubleLine( ( " %s" ):format( right ), left );
                                        pcount = pcount + 1;
                                   else
                                        GameTooltip:AddDoubleLine( ( " %s" ):format( right ), left );
                                        pcount = pcount + 1;
                                   end
                              end
                         end
                    end
               )
	       if ( pcount == 0 ) then GameTooltip:AddLine( LB["TITAN_PALS_TOOLTIP_NO_OFF"] ) end
          end
     end
     -- For showing ignored ppl
     if ( TitanPals.Settings.ShowIgnored ) then
          GameTooltip:AddLine( "\n" );
          GameTooltip:AddLine(TitanPals_ColorUtils( "GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_IGNORE"] ) );
          ni = GetNumIgnores();
          if ( ni == 0 ) then 
               GameTooltip:AddLine( LB["TITAN_PALS_TOOLTIP_IGNORE_EMPTY"] );
          else
               for ofI=1, ni do
                    local tpit = TitanPals_ColorUtils( "GetCText", "red", LB["TITAN_PALS_TOOLTIP_OFFLINE_IGNORED"] );
                    GameTooltip:AddDoubleLine( ( "  %s" ):format( TitanPals_ColorUtils( "GetCText", "normal", GetIgnoreName( ofI ) ) ), tpit );
               end
          end
     end
     -- For showing AddOn memory Usage
     if ( TitanPals.Settings.ShowMem ) then
          GameTooltip:AddLine( "\n" );
          GameTooltip:AddLine( TitanPals_ColorUtils( "GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_MEM"] ) );
	  GameTooltip:AddDoubleLine( ( "  %s" ):format( LB["TITAN_PALS_ADDON_LABEL"] ), TitanPals_ColorUtils( "GetCText", "green", ( "%s kb" ):format( floor( GetAddOnMemoryUsage( "TitanPals" ) ) ) ) )
     end
end